clc;
close all;
clear all;

rand('state',1);
randn('state',1);

L=2;
T=1;

switch L
    case 2
        tl=[0.256 0.38];
        al=[1 0.8];
        K=5;
        N=5;
        p=5;
        %good matrix for N=5
        A =[ -1    -1    -1    -1     1; ,...
            1    -1    -1    -1    -1; ,...
            -1     1    -1    -1    -1; ,...
            -1    -1     1    -1    -1; ,...
            -1    -1    -1     1    -1];

        S=[1 0 0 0 1;,...
            0 1 0 1 0;,...
            0 0 sqrt(2) 0 0;,...
            -j 0 0 0 j;,...
            0 -j 0 j 0];


    case 4
        tl=[0.213 0.452 0.664 0.7453];
        %tl=[0.05 0.25 0.52 0.76];
        al=[1 0.9 0.7 0.6];
        K=9;
        N=9;
        p=9;

        % % good matrix for N=9
        %  A =[1     1     1     1     1     1     1     1    -1; , ...
        %     -1     1     1    -1    -1     1     1    -1     1; , ...
        %     1    -1     1     1     1     1     1    -1    -1; , ...
        %     -1     1    -1    -1     1     1    -1     1    -1; , ...
        %     1    -1     1     1     1    -1     1     1    -1; , ...
        %     -1     1     1    -1    -1     1     1     1    -1; , ...
        %     -1    -1    -1     1    -1    -1     1    -1     1; , ...
        %     1    -1     1    -1     1    -1     1    -1    -1; , ...
        %     -1     1    -1     1     1    -1    -1     1    -1];
        A =[ 1     1     1     1    -1     1     1    -1     1; ,...
            1     1     1     1     1    -1     1     1    -1; ,...
            -1     1     1     1     1     1    -1     1     1; ,...
            1    -1     1     1     1     1     1    -1     1; ,...
            1     1    -1     1     1     1     1     1    -1; ,...
            -1     1     1    -1     1     1     1     1     1; ,...
            1    -1     1     1    -1     1     1     1     1; ,...
            1     1    -1     1     1    -1     1     1     1; ,...
            1     1     1    -1     1     1    -1     1     1];

        S=0.5*[1 0 0 0 0 0 0 0 1;,...
            0 1 0 0 0 0 0 1 0; ,...
            0 0 1 0 0 0 1 0 0;,...
            0 0 0 1 0 1 0 0 0;,...
            0 0 0 0 sqrt(2) 0 0 0 0;,...
            -j 0 0 0 0 0 0 0 j;,...
            0 -j 0 0 0 0 0 j 0; ,...
            0 0 -j 0 0 0 j 0 0;,...
            0 0 0 -j 0 j 0 0 0];
    case  10
        tl=T*((0:L-1)/L+randn(1,L)*0.45/L);
        al=ones(1,L);
        K=21;
        N=21;
        p=21;
        
        load bestA21;
        S=0.5*[eye(L) zeros(L,1) fliplr(eye(L));,...
            zeros(1,L) sqrt(2) zeros(1,L) ;,...
            -j*eye(L) zeros(L,1) j*fliplr(eye(L))];

end
% Exponential filters
alpha=0.2;
beta=0.8;

Sr=fftshift(dftmtx(p),2); % sos matrix

Avg=100;
SNR_vec=0:5:100;
mse_tl=zeros(1,length(SNR_vec)); % rect
mse_tl_m=zeros(1,length(SNR_vec)); % tones
mse_tl_r=zeros(1,length(SNR_vec)); % SoS
mse_tl_g=zeros(1,length(SNR_vec)); % integrators
mse_tl_o=zeros(1,length(SNR_vec)); % exponential filters

c=real(MultiSamp(tl,al,A,N,K,T)); % create samples rect
Ec=sum(abs(c).^2)/p;

cr=real(MultiSampMix(tl,al,Sr,T)); % create samples Sos
Ecr=sum(abs(cr).^2)/p;

cm=MultiSampMix(tl,al,S,T); % tones
Ecm=sum(abs(cm).^2)/p;

cg=IntSamp(tl,al,p,T); % create samples integrators
Ecg=sum(abs(cg).^2)/p;

co=ExpSamp(tl,al,p,T,alpha,beta); % create samples exponential filters
Eco=sum(abs(co).^2)/p;

tic;
for snr_ind=1:length(SNR_vec);
    for avg_ind=1:Avg
        SNR=SNR_vec(snr_ind);

        n0=(randn(size(c)));
        n=10^(-SNR/20)*sqrt(Ec)*n0;
        cn=c+n;
        tl_est=MultiRecover(cn,A,N,K,T,L);
        mse_tl(snr_ind)=mse_tl(snr_ind)+1/L/Avg*sum((tl_est-tl').^2);
        
        nr=10^(-SNR/20)*sqrt(Ecr)*n0;
        cnr=cr+nr;
        tl_est_r=MultiRecoverMix(cnr,Sr,T,L);
        mse_tl_r(snr_ind)=mse_tl_r(snr_ind)+1/L/Avg*sum((tl_est_r-tl').^2);

        nm=10^(-SNR/20)*sqrt(Ecm)*n0;
        cnm=cm+nm;
        tl_est_m=MultiRecoverMix(cnm,S,T,L);
        mse_tl_m(snr_ind)=mse_tl_m(snr_ind)+1/L/Avg*sum((tl_est_m-tl').^2);

        ng=10^(-SNR/20)*sqrt(Ecg)*n0;
        cng=cg+ng;
        tl_est_g=real(IntRecover(cng,T,L));
        mse_tl_g(snr_ind)=mse_tl_g(snr_ind)+1/L/Avg*sum((tl_est_g-tl').^2);
        
        no=10^(-SNR/20)*sqrt(Eco)*n0;
        cno=co+no;
        tl_est_o=real(ExpRecover(cno,T,L,beta));
        mse_tl_o(snr_ind)=mse_tl_o(snr_ind)+1/L/Avg*sum((tl_est_o-tl').^2);
        
        
    end
end
toc;

figure;
hold on;
plot(SNR_vec,10*log10(mse_tl_m),'g','LineWidth',1.5);
plot(SNR_vec,10*log10(mse_tl),'c--','LineWidth',1.5);
plot(SNR_vec,10*log10(mse_tl_r),'r:','LineWidth',1.5);
plot(SNR_vec,10*log10(mse_tl_g),'k.-','LineWidth',1.5);
plot(SNR_vec,10*log10(mse_tl_o),'b-.','LineWidth',1.5);
xlabel('SNR [dB]');
ylabel('MSE [dB]');
grid on;
legend('tones','rectangular','SoS','integrators','exponentials','location','SouthWest');
