function c=MultiSamp(tl,al,A,N,K,T)

% tl - row vectors of delays
% al - row vectors of gains
% A - sequences, a_i[n] in the ith row, p sequences
% N - code length
% K - number of fourier coefficiants to collect
% T - period

% build F 
k=1:K;
k_tag=-(k-floor(K/2)-1);
n=1:N;

[kk,nn]=meshgrid(k,n);
kk_tag=-(kk-floor(K/2)-1);
F=exp(-j*2*pi/N*kk_tag.*(nn-1));

% build Phi - assumption rectangular pulse
w=2*pi/T*k_tag;
P=T/N*exp(-j*T/(2*N)*w).*sinc(T/(2*pi*N)*w);
Phi=diag(P);
%Phi=eye(size(Phi)); % bypass rect

% build S
S=A*F*Phi;

% calc scheme outputs
[Tl,kk]=meshgrid(tl,-floor(K/2):floor(K/2));
W=exp(-j*2*pi/T*Tl.*kk);

c=S*W*al';



